
list        p=16F1827      ; list directive to define processor
#include    <p16f1827.inc>  ; processor specific variable definitions

errorlevel  -302              ; suppress message 302 from list file
    
; CONFIG1
; __config 0xC9A4
 __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
; CONFIG2
; __config 0xDCFF
 __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_LO & _LVP_OFF


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;
;;;;;  M@fR[_ for PIC16F1827
;;;;;
;;;;;  Web Nucky         http://web.nucky.jp/
;;;;;  
;;;;;  Copyright (C) 2007-2016  Nucky
;;;;;
;;;;;    DCC Signal Analysis (0/1 Detection part)
;;;;;     Original Programmed by T.Shimizu (Copyright 2007/6)
;;;;;      http://www.dokidoki.ne.jp/home2/tohrus/marklin.html
;;;;;   
;;;;;  gpPIC}CR PIC16F1827@@U4MHz[h
;;;;;
;;;;;   2016.04.03 Ver 0.9beta  
;;;;;   2016.04.17 Ver 0.91beta  M@t,cύX
;;;;;@@@@@@@@@@@@@@@@@@@@@@@@@iDesktopStation̕Wɏj
;;;;;@@@@@@@@@@@@@@@@@@@@@@@@@~M[po͑
;;;;;@@@@@@@@@@@@@@@@@@@@@@@@@id䓙ɗp\j
;;;;;   2016.09.17 Ver 0.92beta  2M@̃T|[g
;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;
;;;;; DCCMM^C~O@Wl@0x08 at 4MHz
;;;;; 
;;;;;  cbbM̎MɎsꍇ0x06-0x08(16i)̊Ԃ
;;;;;@@ݒςĎĂ݂ĂB
;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;#define		CNT		0x08	; 4MHz
#define		CNT		0x20	; 16MHz


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    o̓s̊蓖āi`j
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#define		DCC_IN		PORTA,2		; DCCM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    bul̐ݒiEEPROMւ̃f[^`j
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	org	0xF000			;
;-----@f[^ -------- CVl ----------------------

	de	.031			;CV1	M@ʐݒ	
	de	.255			;CV2	Pxf	255
	de	.255			;CV3	Pxx	255
	de	.255			;CV4	Pxq	255
	de	.000			;CV5	
	de	.000			;CV6	
	de	.092			;CV7	fR[_u	92
	de	.156			;CV8	hciZbgpj	156
	de	B'00000000'		;CV9	R[hݒ	0
	de	.056			;CV10	}Mݒ	56
	de	.129			;CV11	ĂpAhX	129
	de	.248			;CV12	ĂpAhX	248
	de	.129			;CV13	P@AhX	129
	de	.250			;CV14	P@AhX	250
	de	.129			;CV15	Q@AhX	129
	de	.252			;CV16	Q@AhX	252
	de	.129			;CV17	R@AhX	129
	de	.254			;CV18	R@AhX	254
	de	.130			;CV19	S@AhX	130
	de	.248			;CV20	S@AhX	248
	de	.130			;CV21	T@AhX	130
	de	.250			;CV22	T@AhX	250



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ϐ̒`
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    
    CBLOCK 0x20 ; Define GPR variable register locations

TCNT1	 	;DCCMMpJEg1
TCNT2	 	;DCCMMpJEg2

DATA1		;MoCgP
DATA2		;MoCgQ
DATA3		;MoCgR
DATA4		;MoCgS
DATA5		;MoCgT
DATA6		;MoCgU

DATA20		;MoCgQ̉1bit0

A_ADR01		;P@PoCg
A_ADR02		;P@QoCg
B_ADR01		;Q@PoCg
B_ADR02		;Q@QoCg
C_ADR01		;3@PoCg
C_ADR02		;3@QoCg
D_ADR01		;4@PoCg
D_ADR02		;4@QoCg
E_ADR01		;5@PoCg
E_ADR02		;5@QoCg

KIDO_G		;Pxf
KIDO_Y		;Pxx
KIDO_R		;Pxq

SIGNAL_SET	;M@ʐݒ

GENJI_CODE	;}pgOϐ


P_REG		;PAGE[hݗpϐ1
D_REG		;PAGE[hݗpϐ2
SM_STATUS	;T[rX[hݗpSTATUS
DIRECT_TEMP	;DIRECT[hݗpϐ

CVEEDATA	;EEPROMݗpꎞϐ

TMR_CNT1	;xp^C}ϐ
TMR_CNT2
TMR_CNT3

CNT1		;TIMERpϐ
CNT2
CNT3

YGF_COUNT	;}p^C}ϐ
YGF_TOGGLE	;}pgOϐ
TMR0_INIT	;}pTMR0l

    
    ENDC
 
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ohb}CȐݒ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

		ORG 0x0000

    	GOTO	MAINSTART

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    荞ݏ@
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

		ORG	0x0004

		BTFSS	INTCON,TMR0IF	; TMR0̊荞݁H
    	RETFIE

		BCF		INTCON,TMR0IF	; ^C}[荞݃tOZbg

		BANKSEL	TMR0_INIT
		MOVF	TMR0_INIT,W		; TMR0̏	YGF
		MOVWF	TMR0

		INCF	YGF_COUNT,F		; 荞ݔ񐔂̃JEgAbv

		SUBWF	YGF_COUNT,W
		BTFSS	STATUS,C
		RETFIE
			
		CLRF	YGF_COUNT

		MOVLW	B'00000001'
		XORWF	YGF_TOGGLE

		BTFSS	YGF_TOGGLE,0
		GOTO	YGF_0

YGF_1

		BANKSEL	PSTR1CON
		MOVLW	B'00000110'
		MOVWF	PSTR1CON

		MOVLB	B'00000'
		MOVF	KIDO_G,W
		BANKSEL	CCPR1L
		MOVWF	CCPR1L

		BANKSEL	PSTR2CON
		MOVLW	B'00000010'
		MOVWF	PSTR2CON

		MOVLB	B'00000'
		MOVF	KIDO_Y,W
		BANKSEL	CCPR2L
		MOVWF	CCPR2L

		MOVLB	B'00000'		; BANK0

    	RETFIE

YGF_0

		BANKSEL	PSTR1CON
		MOVLW	B'00000110'
		MOVWF	PSTR1CON

		BANKSEL	CCPR1L
		MOVLW	0x00
		MOVWF	CCPR1L

		BANKSEL	PSTR2CON
		MOVLW	B'00000010'
		MOVWF	PSTR2CON

		BANKSEL	CCPR2L
		MOVLW	0x00
		MOVWF	CCPR2L

		MOVLB	B'00000'		; BANK0

  	 	RETFIE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ohb}CȐݒ 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

MAINSTART

		BANKSEL	OSCCON
		MOVLW	B'01111010'		; CLOCK=16MHz 
;		MOVLW	B'01110010'		; CLOCK=8MHz 
;		MOVLW	B'01101010'		; CLOCK=4MHz 
		MOVWF	OSCCON
 
		BANKSEL	ANSELA			; AN0-AN4̓fW^
		CLRF	ANSELA

		BANKSEL	ANSELB			; AN5-AN11̓fW^
		CLRF	ANSELB
	
		BANKSEL	TRISA
		MOVLW	B'00000100'		; PORTA2͓́Aׂ͂ďo
		MOVWF	TRISA
    
		BANKSEL	TRISB
		MOVLW	B'00000000'		; PORTBׂ͂ďo
		MOVWF	TRISB

		BANKSEL	PORTA
		CLRF	PORTA

		BANKSEL	PORTB
		CLRF	PORTB


TIMER0_SET

		BANKSEL	OPTION_REG
		MOVLW	B'00000110'		; NbNTIMER0gpAvXP[1F128
		MOVWF	OPTION_REG


		BANKSEL	TMR0_INIT
		MOVF	TMR0_INIT,W		; TMR0̏	YGF
		MOVWF	TMR0

;		BANKSEL	TMR0
;		MOVLW	D'14'
;		MOVWF	TMR0
	
		BCF		INTCON,TMR0IF

		MOVLW	D'0'
		MOVWF	YGF_COUNT

		BSF		INTCON,TMR0IE
	
;		BSF		INTCON,GIE

CCP_SET

		BANKSEL	CCP1CON
		MOVLW	B'00001100'		; PWM@\iVOPWM)gp
		MOVWF	CCP1CON

		BANKSEL	CCP2CON
		MOVLW	B'00001100'		; PWM@\iVOPWM)gp
		MOVWF	CCP2CON

		BANKSEL	CCPTMRS
		MOVLW	B'00000100'		; CCP1=TMR2 , CCP2=TMR4
		MOVWF	CCPTMRS

		BANKSEL	APFCON0
		BCF		APFCON0,CCP1SEL	; CCP1̏o͂9ԃs
		BSF		APFCON0,P1CSEL	; P1C̏o͂16ԃs
		BSF		APFCON0,P1DSEL	; P1D̏o͂15ԃs
		BSF		APFCON0,CCP2SEL	; CCP2̏o͂16ԃs
		BSF		APFCON0,P2BSEL	; P2B̏o͂15ԃs


;		BANKSEL	PSTR1CON
;		MOVLW	B'00000011'		; P1A,P1BPWMo
;		MOVWF	PSTR1CON

;		BANKSEL	PR2
;	.	MOVLW	0X7F
;		MOVWF	PR2

;		BANKSEL	PR4
;		MOVLW	0X7F
;		MOVWF	PR4


		BANKSEL	T2CON
		MOVLW	B'000000100'	; POST=1 TMR2ON PRE=1
		MOVWF	T2CON

		BANKSEL	T4CON
		MOVLW	B'000000100'	; POST=1 TMR4ON PRE=1
		MOVWF	T4CON


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    C[v
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
; ϐǂݍ

		MOVLW	.00					
		CALL	EEPROM_READ
		MOVWF	SIGNAL_SET

		MOVLW	.01					
		CALL	EEPROM_READ
		MOVWF	KIDO_G

		MOVLW	.02					
		CALL	EEPROM_READ
		MOVWF	KIDO_Y

		MOVLW	.03					
		CALL	EEPROM_READ
		MOVWF	KIDO_R

		MOVLW	.09					
		CALL	EEPROM_READ
		MOVWF	TMR0_INIT

		MOVLW	.12					
		CALL	EEPROM_READ
		MOVWF	A_ADR01

		MOVLW	.13
		CALL	EEPROM_READ
		MOVWF	A_ADR02

		MOVLW	.14
		CALL	EEPROM_READ
		MOVWF	B_ADR01

		MOVLW	.15
		CALL	EEPROM_READ
		MOVWF	B_ADR02

		MOVLW	.16
		CALL	EEPROM_READ
		MOVWF	C_ADR01

		MOVLW	.17
		CALL	EEPROM_READ
		MOVWF	C_ADR02

		MOVLW	.18
		CALL	EEPROM_READ
		MOVWF	D_ADR01

		MOVLW	.19
		CALL	EEPROM_READ
		MOVWF	D_ADR02

		MOVLW	.20
		CALL	EEPROM_READ
		MOVWF	E_ADR01

		MOVLW	.21
		CALL	EEPROM_READ
		MOVWF	E_ADR02

MAIN

		BANKSEL	PORTA
		CLRF	PORTA			; PORTA
		CLRF	PORTB			; PORTBA
		CLRF	SM_STATUS		; PageModeflag̃NA


;		CALL	RED				;@

		MOVLW	.8
		CALL	EEPROM_READ
		MOVWF	GENJI_CODE

		GOTO	GENJI


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       cbbpPbgǂݍݏ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STEP001

		CLRF	DATA1
		CLRF	DATA2
		CLRF	DATA3
		CLRF	DATA4
		CLRF	DATA5
		CLRF	DATA6

        CLRF	TCNT1
        CLRF  	TCNT2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       vAuo@("1"14Ao)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AA01
        BTFSC	DCC_IN
        GOTO	AA05		 
        BTFSC	DCC_IN
        GOTO	AA06		 
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	AA01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	AA07         
                      
        INCF	TCNT2,F    
        MOVLW	0x0C      		 ; 0x0C(14)bit"1" 
        SUBWF	TCNT2,W
        BTFSC	STATUS,Z  
        GOTO	STEP002
        CLRF	TCNT1   
        GOTO	AA01
AA05    NOP					 
        NOP 				 
AA06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	AA01
AA07    CLRF	TCNT1
        CLRF	TCNT2
        GOTO	AA01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;@@@@ pPbgX^[grbgo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STEP002
        CLRF	TCNT1
        CLRF	TCNT2

BB01
        BTFSC	DCC_IN
        GOTO	BB05        
        BTFSC	DCC_IN
        GOTO	BB06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	BB01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	STEP003     
                          
        CLRF	TCNT1   
        GOTO	BB01
BB05    NOP 			 
        NOP				 
BB06    NOP				 
        NOP				 
        INCF	TCNT1,F      
        GOTO	BB01

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    PoCgǂݍ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
STEP003

		CLRF	TMR1L			; pPbgX^[grbg𐳏ǂݍ݂TMR10
		CLRF	TMR1H			; iDCCMȂꍇA莞ԂŃAiOׁj

        CLRF	TCNT1
        CLRF	TCNT2
        BSF		TCNT2,3

CC01
        BTFSC	DCC_IN
        GOTO	CC05        
        BTFSC	DCC_IN
        GOTO	CC06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	CC01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	CC08         
               	   
        RLF		DATA1,F
        BSF		DATA1,0
        DECFSZ	TCNT2,F
        GOTO	CC09
        GOTO	CC20

CC09    CLRF	TCNT1    
        GOTO	CC01

CC05    NOP 				 
        NOP					 
CC06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	CC01
CC08
        RLF		DATA1,F
        BCF		DATA1,0
        DECFSZ	TCNT2,F
        GOTO	CC09

CC20

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        f[^oCgX^[grbgo@iPQj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STEP004
        CLRF	TCNT1
        CLRF	TCNT2

DD01
        BTFSC	DCC_IN
        GOTO	DD05        
        BTFSC	DCC_IN
        GOTO	DD06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	DD01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	STEP005     
                      
        CLRF 	TCNT1   
        GOTO	STEP001		
DD05    NOP					 
        NOP					 
DD06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	DD01



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      Q@oCgǂݍ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STEP005
        CLRF	TCNT1
        CLRF	TCNT2
        BSF		TCNT2,3  

EE01
        BTFSC	DCC_IN
        GOTO	EE05        
        BTFSC	DCC_IN
        GOTO	EE06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	EE01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	EE08         
                   
        RLF		DATA2,F
        BSF		DATA2,0
        DECFSZ	TCNT2,F
        GOTO	EE09
        GOTO	EE20

EE09    CLRF	TCNT1  
        GOTO	EE01

EE05    NOP					 
        NOP					 
EE06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	EE01
EE08
        RLF		DATA2,F
        BCF		DATA2,0
        DECFSZ	TCNT2,F
        GOTO	EE09

EE20


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        f[^oCgX^[grbgo@iQRj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STEP006
        CLRF	TCNT1
        CLRF	TCNT2

FF01
        BTFSC	DCC_IN
        GOTO	FF05        
        BTFSC	DCC_IN
        GOTO	FF06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	FF01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C  
        GOTO	STEP007      
                      
        CLRF	TCNT1    
        GOTO	STEP001
FF05    NOP					 
        NOP					 
FF06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	FF01


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        OoCgǂݍ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STEP007
        CLRF	TCNT1
        CLRF	TCNT2
        BSF		TCNT2,3  

GG01
        BTFSC	DCC_IN
        GOTO	GG05        
        BTFSC	DCC_IN
        GOTO	GG06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	GG01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	GG08         
                         
        RLF		DATA3,F
        BSF		DATA3,0
        DECFSZ	TCNT2,F
        GOTO	GG09
        GOTO	GG20

GG09    CLRF	TCNT1   
        GOTO	GG01

GG05    NOP   
        NOP   
GG06    NOP   
        NOP   
        INCF	TCNT1,F      
        GOTO	GG01
GG08
        RLF		DATA3,F
        BCF		DATA3,0
        DECFSZ	TCNT2,F
        GOTO	GG09
GG20

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        f[^oCgX^[grbgo@iRSj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STEP008
        CLRF	TCNT1
        CLRF	TCNT2

HH01
        BTFSC	DCC_IN
        GOTO	HH05        
        BTFSC	DCC_IN
        GOTO	HH06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	HH01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C  
        GOTO	STEP081    
                      
        CLRF	TCNT1    
        GOTO	CHK_ERR	; pPbgGhȂG[ʂ 
HH05    NOP					 
        NOP 				 
HH06    NOP					 
        NOP				 	 
        INCF	TCNT1,F      
        GOTO	HH01

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        loCgǂݍ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STEP081
        CLRF	TCNT1
        CLRF	TCNT2
        BSF		TCNT2,3 

II01
        BTFSC	DCC_IN
        GOTO	II05        
        BTFSC	DCC_IN
        GOTO	II06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	II01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	II08         
                     
        RLF		DATA4,F
        BSF		DATA4,0
        DECFSZ	TCNT2,F
        GOTO	II09
        GOTO	II20

II09    CLRF	TCNT1   
        GOTO	II01

II05    NOP				 
        NOP				 
II06    NOP				 
        NOP				 
        INCF	TCNT1,F      
        GOTO	II01
II08
        RLF		DATA4,F
        BCF		DATA4,0
        DECFSZ	TCNT2,F
        GOTO	II09

II20



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        f[^oCgX^[grbgo@iSTj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STEP082
        CLRF	TCNT1
        CLRF	TCNT2

JJ01
        BTFSC	DCC_IN
        GOTO	JJ05        
        BTFSC	DCC_IN
        GOTO	JJ06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	JJ01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C  
        GOTO	STEP083  

        CLRF	TCNT1   
        GOTO	CHK_ERR	;pPbgGhrbguPvoCHK_ERR
JJ05    NOP					 
        NOP					 
JJ06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	JJ01



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        ToCgǂݍ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STEP083
        CLRF	TCNT1
        CLRF	TCNT2
        BSF		TCNT2,3 

KK01
        BTFSC	DCC_IN
        GOTO	KK05        
        BTFSC	DCC_IN
        GOTO	KK06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	KK01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C   
        GOTO	KK08         
                        
        RLF		DATA5,F
        BSF		DATA5,0
        DECFSZ	TCNT2,F
        GOTO	KK09
        GOTO	KK20

KK09    CLRF	TCNT1  
        GOTO	KK01

KK05    NOP				 
        NOP				 
KK06    NOP				 
        NOP				 
        INCF	TCNT1,F      
        GOTO	KK01
KK08
        RLF		DATA5,F
        BCF		DATA5,0
        DECFSZ	TCNT2,F
        GOTO	KK09

KK20



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        f[^oCgX^[grbgo@iTUj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STEP084
        CLRF	TCNT1
        CLRF	TCNT2

LL01
        BTFSC	DCC_IN
        GOTO	LL05        
        BTFSC	DCC_IN
        GOTO	LL06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	LL01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C  
        GOTO	STEP009  




        CLRF	TCNT1   
        GOTO	CHK_ERR	;pPbgGhrbguPvoCHK_ERR

LL05    NOP					 
        NOP					 
LL06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	LL01




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        UoCgǂݍ݁@iŏIoCgj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STEP009
        CLRF	TCNT1
        CLRF	TCNT2
        BSF		TCNT2,3 
 
MM01
        BTFSC	DCC_IN
        GOTO	MM05        
        BTFSC	DCC_IN
        GOTO	MM06        
        MOVLW	0x00
        SUBWF	TCNT1,W
        BTFSC	STATUS,Z
        GOTO	MM01
        MOVLW	CNT        
        SUBWF	TCNT1,W
        BTFSC	STATUS,C  
        GOTO	MM08         
                       
        RLF		DATA6,F
        BSF		DATA6,0
        DECFSZ	TCNT2,F
        GOTO	MM09
        GOTO	MM20

MM09    CLRF	TCNT1 
        GOTO	MM01

MM05    NOP					 
        NOP					 
MM06    NOP					 
        NOP					 
        INCF	TCNT1,F      
        GOTO	MM01
MM08
        RLF		DATA6,F
        BCF		DATA6,0
        DECFSZ	TCNT2,F
        GOTO	MM09
MM20

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;  DCCpPbg@G[`FbN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CHK_ERR
		MOVF	DATA1,W			;       DATA1 -> W
		XORWF	DATA2,W			; W XOR DATA2 -> W
		XORWF	DATA3,W			; W XOR DATA3 -> W
		XORWF	DATA4,W			; W XOR DATA4 -> W
		XORWF	DATA5,W			; W XOR DATA5 -> W
		XORWF	DATA6,W			; W XOR DATA6 -> W
		BTFSS	STATUS,Z
		GOTO	STEP001			; ʂOɂȂȂiG[jȂSTEP001֖߂


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;  oCg̔ʁ@iAhX̏j
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;00000000 (0)				: Broadcast address
;00000001-01101111 (001-111): Multi-Function decoders with 7 bit addresses
;01110000-01111111 (112-127): Service Mode
;10000000-10111111 (128-191): Basic Accessory Decoders with 9 bit addresses and Extended Accessory Decoders with 11-bit addresses
;11000000-11100111 (192-231): Multi Function Decoders with 14 bit addresses
;11101000-11111110 (232-254): Reserved for Future Use
;11111111 (255)				: Idle Packet

ADRREAD					

		MOVF	DATA2,W
		ANDLW	b'11111110'	; DATA27-1BIT𔲂o DATA20 
		MOVWF	DATA20


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ߉͏@iPj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


A_ADR_CHK01
		MOVF	DATA1,W		;@DATA1͏PAhXƈv邩H
		XORWF	A_ADR01,W
		BTFSS	STATUS,Z
		GOTO	B_ADR_CHK01

A_ADR_CHK02
		MOVF	DATA20,W	;@DATA20͏PAhXƈv邩H
		XORWF	A_ADR02,W
		BTFSS	STATUS,Z
		GOTO	B_ADR_CHK01

A_T_C_CHK
		BTFSC	DATA2,0		; DATA2 bit0@ 1/0?
		GOTO	A_C_CONT

A_T_CONT					; P@ C=0(OFF)

		BCF		GENJI_CODE,0
		GOTO	GENJI

A_C_CONT					;@P@@ C=1(ON)

		BSF		GENJI_CODE,0
		GOTO	GENJI


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ߉͏@i2j
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


B_ADR_CHK01
		MOVF	DATA1,W		;@DATA1͏2AhXƈv邩H
		XORWF	B_ADR01,W
		BTFSS	STATUS,Z
		GOTO	C_ADR_CHK01

B_ADR_CHK02
		MOVF	DATA20,W	;@DATA20͏2AhXƈv邩H
		XORWF	B_ADR02,W
		BTFSS	STATUS,Z
		GOTO	C_ADR_CHK01

B_T_C_CHK
		BTFSC	DATA2,0		; DATA2 bit0@ 1/0?
		GOTO	B_C_CONT

B_T_CONT					; 2@ C=0(OFF)

		BCF		GENJI_CODE,1
		GOTO	GENJI

B_C_CONT					;@2@@ C=1(ON)

		BSF		GENJI_CODE,1
		GOTO	GENJI



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ߉͏@i3j
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


C_ADR_CHK01
		MOVF	DATA1,W		;@DATA1͏3AhXƈv邩H
		XORWF	C_ADR01,W
		BTFSS	STATUS,Z
		GOTO	D_ADR_CHK01

C_ADR_CHK02
		MOVF	DATA20,W	;@DATA20͏2AhXƈv邩H
		XORWF	C_ADR02,W
		BTFSS	STATUS,Z
		GOTO	D_ADR_CHK01

C_T_C_CHK
		BTFSC	DATA2,0		; DATA2 bit0@ 1/0?
		GOTO	C_C_CONT

C_T_CONT					; 3@ C=0(OFF)

		BCF		GENJI_CODE,2
		GOTO	GENJI

C_C_CONT					;@3@@ C=1(ON)

		BSF		GENJI_CODE,2
		GOTO	GENJI



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ߉͏@i4j
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


D_ADR_CHK01
		MOVF	DATA1,W		;@DATA1͏4AhXƈv邩H
		XORWF	D_ADR01,W
		BTFSS	STATUS,Z
		GOTO	E_ADR_CHK01

D_ADR_CHK02
		MOVF	DATA20,W	;@DATA20͏4AhXƈv邩H
		XORWF	D_ADR02,W
		BTFSS	STATUS,Z
		GOTO	E_ADR_CHK01

D_T_C_CHK
		BTFSC	DATA2,0		; DATA2 bit0@ 1/0?
		GOTO	D_C_CONT

D_T_CONT					; 4@ C=0(OFF)

		BCF		GENJI_CODE,3
		GOTO	GENJI

D_C_CONT					;@4@@ C=1(ON)

		BSF		GENJI_CODE,3
		GOTO	GENJI

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    ߉͏@i5j
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


E_ADR_CHK01
		MOVF	DATA1,W		;@DATA1͏4AhXƈv邩H
		XORWF	E_ADR01,W
		BTFSS	STATUS,Z
		GOTO	CHK_DATA1

E_ADR_CHK02
		MOVF	DATA20,W	;@DATA20͏4AhXƈv邩H
		XORWF	E_ADR02,W
		BTFSS	STATUS,Z
		GOTO	CHK_DATA1

E_T_C_CHK
		BTFSC	DATA2,0		; DATA2 bit0@ 1/0?
		GOTO	E_C_CONT

E_T_CONT					; 5@ C=0(OFF)

		BCF		GENJI_CODE,4
		GOTO	GENJI

E_C_CONT					;@5@@ C=1(ON)

		BSF		GENJI_CODE,4
		GOTO	GENJI


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    \
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GENJI

		MOVLW	D'21'		; 2
		XORWF	SIGNAL_SET,W
		BTFSC	STATUS,Z
		GOTO	SIGNAL_21

		MOVLW	D'31'		; 3
		XORWF	SIGNAL_SET,W
		BTFSC	STATUS,Z
		GOTO	SIGNAL_31

		MOVLW	D'41'		; 4YY
		XORWF	SIGNAL_SET,W
		BTFSC	STATUS,Z
		GOTO	SIGNAL_41

		MOVLW	D'42'		; 4YG
		XORWF	SIGNAL_SET,W
		BTFSC	STATUS,Z
		GOTO	SIGNAL_42

		MOVLW	D'43'		; 4YGF
		XORWF	SIGNAL_SET,W
		BTFSC	STATUS,Z
		GOTO	SIGNAL_43

		MOVLW	D'51'		; 5
		XORWF	SIGNAL_SET,W
		BTFSC	STATUS,Z
		GOTO	SIGNAL_51

		MOVLW	D'52'		; 5YGF
		XORWF	SIGNAL_SET,W
		BTFSC	STATUS,Z
		GOTO	SIGNAL_52

; Q
SIGNAL_21

GENJI_21A
		BTFSC	GENJI_CODE,0
		GOTO	GENJI_21B
		CALL	RED
		GOTO	GENJI_END

GENJI_21B
		CALL	GREEN
		GOTO	GENJI_END

; R
SIGNAL_31

GENJI_31A
		BTFSC	GENJI_CODE,0
		GOTO	GENJI_31B
		CALL	RED
		GOTO	GENJI_END

GENJI_31B
		BTFSC	GENJI_CODE,1
		GOTO	GENJI_31C
		CALL	YELLOW
		GOTO	GENJI_END

GENJI_31C
		CALL	GREEN
		GOTO	GENJI_END

; Sxx
SIGNAL_41

GENJI_41A
		BTFSC	GENJI_CODE,0
		GOTO	GENJI_41B
		CALL	RED
		GOTO	GENJI_END

GENJI_41B
		BTFSC	GENJI_CODE,1
		GOTO	GENJI_41C
		CALL	YY
		GOTO	GENJI_END

GENJI_41C
		BTFSC	GENJI_CODE,2
		GOTO	GENJI_41D
		CALL	YELLOW
		GOTO	GENJI_END

GENJI_41D
		CALL	GREEN
		GOTO	GENJI_END


; Sxf
SIGNAL_42

GENJI_42A
		BTFSC	GENJI_CODE,0
		GOTO	GENJI_42B
		CALL	RED
		GOTO	GENJI_END

GENJI_42B
		BTFSC	GENJI_CODE,1
		GOTO	GENJI_42C
		CALL	YELLOW
		GOTO	GENJI_END

GENJI_42C
		BTFSC	GENJI_CODE,2
		GOTO	GENJI_42D
		CALL	YG
		GOTO	GENJI_END

GENJI_42D
		CALL	GREEN
		GOTO	GENJI_END


; Sxfe
SIGNAL_43

GENJI_43A
		BTFSC	GENJI_CODE,0
		GOTO	GENJI_43B
		CALL	RED
		GOTO	GENJI_END

GENJI_43B
		BTFSC	GENJI_CODE,1
		GOTO	GENJI_43C
		CALL	YELLOW
		GOTO	GENJI_END

GENJI_43C
		BTFSC	GENJI_CODE,2
		GOTO	GENJI_43D
		CALL	YG
		GOTO	GENJI_END

GENJI_43D
		BTFSC	GENJI_CODE,3
		GOTO	GENJI_43E
		CALL	YGF
		GOTO	GENJI_END

GENJI_43E
		CALL	GREEN
		GOTO	GENJI_END


; T
SIGNAL_51

GENJI_51A
		BTFSC	GENJI_CODE,0
		GOTO	GENJI_51B
		CALL	RED
		GOTO	GENJI_END

GENJI_51B
		BTFSC	GENJI_CODE,1
		GOTO	GENJI_51C
		CALL	YY
		GOTO	GENJI_END

GENJI_51C
		BTFSC	GENJI_CODE,2
		GOTO	GENJI_51D
		CALL	YELLOW
		GOTO	GENJI_END

GENJI_51D
		BTFSC	GENJI_CODE,3
		GOTO	GENJI_51E
		CALL	YG
		GOTO	GENJI_END

GENJI_51E
		CALL	GREEN
		GOTO	GENJI_END




; Ti}j
SIGNAL_52

GENJI_52A
		BTFSC	GENJI_CODE,0
		GOTO	GENJI_52B
		CALL	RED
		GOTO	GENJI_END

GENJI_52B
		BTFSC	GENJI_CODE,1
		GOTO	GENJI_52C
		CALL	YY
		GOTO	GENJI_END

GENJI_52C
		BTFSC	GENJI_CODE,2
		GOTO	GENJI_52D
		CALL	YELLOW
		GOTO	GENJI_END

GENJI_52D
		BTFSC	GENJI_CODE,3
		GOTO	GENJI_52E
		CALL	YG
		GOTO	GENJI_END

GENJI_52E
		BTFSC	GENJI_CODE,4
		GOTO	GENJI_52F
		CALL	YGF
		GOTO	GENJI_END

GENJI_52F
		CALL	GREEN
		GOTO	GENJI_END

GENJI_END

		MOVLW	.00					
		CALL	EEPROM_READ
		MOVWF	SIGNAL_SET

		GOTO	STEP001

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


CHK_DATA1

		COMF	DATA1,W			; AChpPbgH
		BTFSS	STATUS,Z
		GOTO	CHK_DATA1_2		; 

		CLRF	SM_STATUS		; ߹ĂȂSM_STATUSر 
		GOTO	STEP001			; STEP001ɖ߂

CHK_DATA1_2

		MOVF	DATA1,W			; u[hLXgAhXȂ
		BTFSC	STATUS,Z
		GOTO	DCDR_CNT		; ~

		BTFSC	DATA1,7			; DATA1bit7mFu0vȂ玟߂𽷯
		GOTO	CHK_LONGADR		; 4AhX̊mF

		ANDLW	0x70			; T[rX[h̊mF			
		XORLW	0x70
		BTFSC	STATUS,Z
		GOTO	CHECK_SM	 

CHK_ADR

		CLRF	SM_STATUS		; PageModeflag̵ٸر

;		MOVLW	.28				; CV29EEPROMǂݍ
;		CALL	EEPROM_READ
;		MOVWF	CV29
;		BTFSC	CV29,5			; CV29bit52AhXLƂȂĂ邩̊mF
		GOTO	STEP001			; LłȂȂSTEP001֖߂

;		MOVLW	.00				; 2AhX̊mF@@oCgCV01ƈvH@iEEPROM̃AhXCVԍ-1j
;		CALL	EEPROM_READ
;		XORWF	DATA1,W
;		BTFSS	STATUS,Z
;		GOTO	STEP001			; svȂSTEP001
;		GOTO	DECODE			;@vȂDECODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;  SAhX̏
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CHK_LONGADR

		CLRF	SM_STATUS		; PageModeflag̵كNA
	
;		MOVLW	.28				; CV29EEPROMǂݍ
;		CALL	EEPROM_READ
;		MOVWF	CV29
;		BTFSS	CV29,5			; CV29bit5łSAhXLƂȂĂ邩̊mF
		GOTO	STEP001			; LłȂȂSTEP001֖߂



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;  샂[hbu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CV_Access

		MOVLW	B'11101100'		; bũoCĝ݂݃T|[giemFArbg͖T|[gj
		SUBWF	DATA2,W
		BTFSS	STATUS,Z
		GOTO	STEP001 		; ߂vȂSTEP001

		MOVLW	.07				; ݖ߂̂bu͂buWH
		XORWF	DATA3,W
		BTFSC	STATUS,Z
		GOTO	CV_RESET		; buWȂCV_RESET

		MOVF	DATA4,W			; ރf[^CVEEDATAɓǂݍ
		MOVWF	CVEEDATA

		MOVF	DATA3,W			; ރAhXWɓǂݍ

		CALL	EEPROM_WRITE			

		GOTO	MAIN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;  T[rX[h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHECK_SM

		; ڽ112-127޽Ӱނs

		BTFSS	SM_STATUS,0		; ؾ߹Ă͎Mς݂H
		GOTO	CHK_ADR			; ڽ112-127Ƃ2ڽ

		MOVF	DATA4,F			; 3oCg(PAGE[h)A4oCg(DIRECT[h)?
		BTFSC	STATUS,Z		; 4oCgڂ[(PAGE[h)ȂZtO1BDIRECT[hȂZtO0B
		GOTO	PAGE_MODE		; ZtO0ȂA{߂XLbv



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  chqdbs[h
;
; CC = 01 Verify Byte
; CC = 11 Write Byte
;
; Long-preamble 0 0111CCAA 0 AAAAAAAA 0 DDDDDDDD 0 EEEEEEEE 1
;                  DATA1      DATA2      DATA3      DATA4
;
; CC = 10 Bit Manipulation
;
; Long-preamble 0 011110AA 0 AAAAAAAA 0 111KDBBB 0 EEEEEEEE 1
;                  DATA1      DATA2      DATA3      DATA4
;
; K = 0 Bit Verify , K = 1 Bit Write
; D = Bit Data
; BBB = Bit Position (000=bit0)
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DIRECT_MODE

; Bit Manipulation / Verify ^ Write@

		MOVF	DATA1,W
		XORLW	B'01111000'		; CC=10 Bit Manipulation
		BTFSC	STATUS,Z
		GOTO	DIRECT_BIT

		MOVF	DATA1,W
		XORLW	B'01110100'		; CC=01 Verify Byte
		BTFSC	STATUS,Z
		GOTO	DIRECT_VERIFY

		MOVF	DATA1,W
		XORLW	B'01111100'		; CC=11 Write Byte
		BTFSC	STATUS,Z
		GOTO	DIRECT_WRITE

		GOTO	STEP001

DIRECT_BIT						; Bit Manipulation

		BTFSC	DATA3,4			; K=0(Verify)̖߂XLbv
		GOTO	STEP001			;

		MOVF	DATA2,W			; DATA2ŎwCVǂݍ
		CALL	EEPROM_READ
		MOVWF	DIRECT_TEMP		; DIRECT_TEMPɃRs[

		CALL	BIT_TBL			; Tu[`Ăяo

		ANDWF	DIRECT_TEMP,F	; CVۑlrbgʒuAND

		BTFSS	DATA3,3			; BitData=u1vȂ玟߂XLbv		
		GOTO	BIT0_CHK

BIT1_CHK						; Bitu1v`FbN
		MOVF	DIRECT_TEMP,W	; rbgʒu[̃`FbN
		BTFSS	STATUS,Z
		CALL	BASIC_ACK
		GOTO	STEP001

BIT0_CHK						; Bitu0v`FbN
		MOVF	DIRECT_TEMP,W	; rbgʒu[łȂƃ`FbN
		BTFSC	STATUS,Z
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001

BIT_TBL							; Tu[`
								; 3rbg̐lrbgʒu̓
		MOVLW	0x03			; e[u0x300-0x3FFԒnɑ[mFCv]
		MOVWF	PCLATH

		MOVF	DATA3,W			; DATA3 -> W
		ANDLW	B'00000111'		;@DATA3̉3BIT̒o
		ADDWF	PCL,F
		RETLW	B'00000001'		; u0v̂ƂBitu0v
		RETLW	B'00000010'		; u1v̂ƂBitu1v
		RETLW	B'00000100'		; u2v̂ƂBitu2v
		RETLW	B'00001000'		; u3v̂ƂBitu3v
		RETLW	B'00010000'		; u4v̂ƂBitu4v
		RETLW	B'00100000'		; u5v̂ƂBitu5v
		RETLW	B'01000000'		; u6v̂ƂBitu6v
		RETLW	B'10000000'		; u7v̂ƂBitu7v

DIRECT_VERIFY

		MOVF	DATA2,W			; DATA2ŎwCVǂݍ
		CALL	EEPROM_READ
		SUBWF	DATA3,W			; DATA3Ɣr
		BTFSS	STATUS,Z		; vZ=1@svZ=0
		GOTO	STEP001			; svȂǂݍ݌p
								
		CLRF	SM_STATUS		; ServiceMode
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001			; 

DIRECT_WRITE

; cv8ȂCV_default_WRITE
		MOVLW	.07				; buWւ̏H@iݖ߂Hj
		XORWF	DATA2,W
		BTFSS	STATUS,Z		; 0x07ȂXLbv
		GOTO	DIRECT_WRITE2	

		MOVLW	.08				; ݂̒l0x08H			
		XORWF	DATA3,W
		BTFSS	STATUS,Z
		GOTO	CV_default_WRITE_END	; 0x08ȊOȂCV_default_WRITE_END
		GOTO	CV_default_WRITE

DIRECT_WRITE2

		MOVF	DATA3,W			; DATA3̓eCVɏ
		MOVWF	CVEEDATA		;
		MOVF	DATA2,W			; DATA2 -> W  
		CALL	EEPROM_WRITE	;
		CLRF	SM_STATUS		; DIRECT[h݊
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001			; 





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;  o`fd[h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PAGE_MODE

		BTFSS	DATA1,2			; BIT20ȂDataRegister 0-3
		GOTO	DATA_REG		; BIE2=1Ȃ罷

		BTFSC	DATA1,1			; BIT10ȂBasicConfRegiPagingRegister
		GOTO	STEP001			; Bit=0Ȃ罷

		BTFSS	DATA1,0			; BIT1 0ȂBasicConfRegi@1ȂPagingRegister	
		GOTO	BSC_CNF_REG		;@BIT=1Ȃ罷
		GOTO	PAGE_REG		;

PAGE_REG
		MOVF	DATA2,W			; DATA2 -> W
		MOVWF	P_REG			; W -> P_REG
		DECF	P_REG,F			; P_REG - 1 -> P_REG
		BCF		STATUS,C		; P_REG * 4 -> P_REG
		RLF		P_REG			;
		BCF		STATUS,C		;
		RLF		P_REG			;
		BSF		SM_STATUS,1		; PageMode PageRegiǂݍݍς
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001			; 

DATA_REG
		BTFSS	SM_STATUS,1		; SM_STATUSBIT11Ȃ珈pA0ȂSTEP001
		GOTO	STEP001			; BIT1=1Ȃ罷

		MOVF	DATA1,W			; DATA1 -> W
		ANDLW	B'00000011'		; BIT0,1o
		ADDWF	P_REG,W			; P_REGɉAD_REGɑ
		MOVWF	D_REG

; cv8ȂCV_default_WRITE
		MOVLW	.07				; buWւ̏H@iݖ߂Hj
		XORWF	D_REG,W
		BTFSC	STATUS,Z
		GOTO	PM_CV_RESET		; WȂCV_default_WRITE

		BTFSS	DATA1,3			; WRITE[hH@VerifyH
		GOTO	DATA_REG_VERIFY	; BIT3=1(Write[h)Ȃ罷

DATA_REG_WRITE
		MOVF	DATA2,W			; DATA2̓eCVɏ
		MOVWF	CVEEDATA		;
		MOVF	D_REG,W			; D_REG -> W  
		CALL	EEPROM_WRITE	;
		CLRF	D_REG
		CLRF	SM_STATUS		; PageMode݊
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001			; 

DATA_REG_VERIFY
		MOVF	D_REG,W			; D_REGŎwCVǂݍ
		CALL	EEPROM_READ
		SUBWF	DATA2,W			; DATA2Ɣr
		BTFSS	STATUS,Z		; vZ=1@svZ=0
		GOTO	STEP001			; svȂǂݍ݌p
								
		CLRF	D_REG			; vڼ޽رACK
		CLRF	SM_STATUS		; PageMode݊
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001			; 
	
BSC_CNF_REG

		BTFSS	SM_STATUS,1		; SM_STATUSBIT11Ȃ珑݁A0Ȃ珑܂Ȃ
		GOTO	STEP001			; BIT1=1Ȃ罷

		BTFSS	DATA1,3			; WRITE[hH@VerifyH
		GOTO	BSC_CNF_VERFY	; BIT3=1(Write[h)Ȃ罷

BSC_CNF_WRITE
		MOVF	DATA2,W			; DATA2̓eCV29ɏ
		MOVWF	CVEEDATA		;
		MOVLW	.28				; 
		CALL	EEPROM_WRITE	;
		CLRF	P_REG
		CLRF	SM_STATUS		; PageMode݊
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001			;

BSC_CNF_VERFY
		MOVLW	.28				; CV29̓ǂݍ
		CALL	EEPROM_READ
		SUBWF	DATA2,W			; DATA2Ɣr
		BTFSS	STATUS,Z		; vZ=1@svZ=0
		GOTO	STEP001			; svȂǂݍ݌p
								
		CLRF	P_REG			; vڼ޽رACK
		CLRF	SM_STATUS		; PageMode݊
		CALL	BASIC_ACK		; BASIC ACK 
		GOTO	STEP001			; 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;  fR[_A䖽߁@iĒ~̂݃T|[gj
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DCDR_CNT

		MOVF	DATA1,W			; 1޲Ă0x00A2oCg0x00Ȃ
		XORWF	DATA2,W			; fR[_Zbg߂ł
		BTFSS	STATUS,Z		; Xor0Ȃ玟߂XLbv
		GOTO	STEP001

		BSF		SM_STATUS,0		; RESET߹ĎMς׸޾

		CLRF	PORTB

		GOTO	STEP001			; x𔽉f̂DCCM̓ǂݎ

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  EEPROM̏݁Aǂݍ݁@iTu[`j  CVݒEEPROMɕۑAǂݏo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

EEPROM_WRITE
; ݃AhXWɁA݃f[^CVEEDATA
		
		BANKSEL	EEADRL
		MOVWF	EEADRL

		MOVLB	B'00000'	; BANK0
		MOVF	CVEEDATA,W

		BANKSEL	EEDATL
		MOVWF	EEDATL
		BSF	EECON1,WREN
		MOVLW	0x55
		MOVWF	EECON2
		MOVLW	0xAA
		MOVWF	EECON2
		BSF	EECON1,WR
WRITE_WAIT
		BTFSC	EECON1,WR
		GOTO	WRITE_WAIT

		MOVLB	B'00000'	; BANK0
		
		RETURN

EEPROM_READ
; ǂݍ݃AhXWɁAǂݍ񂾃f[^W
		BANKSEL	EEADRL
		MOVWF	EEADRL
		BSF	EECON1,RD
		MOVF	EEDATL,W
		
		MOVLB	B'00000'	; BANK0

		RETURN



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  bul̃Zbg@PageMode ̍ہ@buWݖ߂̒l͂WH
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PM_CV_RESET
		MOVLW	.08			
		XORWF	DATA2,W
		BTFSS	STATUS,Z
		GOTO	CV_default_WRITE_END	; WȊOȂCV_default_WRITE_END
		GOTO	CV_default_WRITE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  bul̃Zbg@buWݖ߂̒l͂WH
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CV_RESET
		MOVLW	.08			
		XORWF	DATA4,W
		BTFSS	STATUS,Z
		GOTO	STEP001		; WȊOȂSTEP001

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  bul̃Zbg@iTu[`j  buݒԂɂǂ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CV_default_WRITE

;=====@buOP ====================================

		MOVLW	.31		; l31
		MOVWF	CVEEDATA	;
		MOVLW	.00			; 
		CALL	EEPROM_WRITE;			

;=====@buOQ@@====================================

		MOVLW	.255		; l255
		MOVWF	CVEEDATA	;
		MOVLW	.01			; 
		CALL	EEPROM_WRITE;				

;=====@buOR@@=====================================

		MOVLW	.255	; l255
		MOVWF	CVEEDATA	;
		MOVLW	.02			; 
		CALL	EEPROM_WRITE;	

;=====@buOS @====================================

		MOVLW	.255		; l255
		MOVWF	CVEEDATA	;
		MOVLW	.03			; 
		CALL	EEPROM_WRITE;	

;=====@buOT @====================================

		MOVLW	.0		; l0
		MOVWF	CVEEDATA	;
		MOVLW	.04			; 
		CALL	EEPROM_WRITE;

;=====@buOU @====================================

		MOVLW	.0		; l0
		MOVWF	CVEEDATA	;
		MOVLW	.05		; 
		CALL	EEPROM_WRITE;

;=====@buOV @====================================

		MOVLW	.92		; l92
		MOVWF	CVEEDATA	;
		MOVLW	.06		; 
		CALL	EEPROM_WRITE;

;=====@buOW @====================================

		MOVLW	.156		; l156
		MOVWF	CVEEDATA	;
		MOVLW	.07		; 
		CALL	EEPROM_WRITE;

;=====@buOX @====================================

		MOVLW	b'00000000'		; l0
		MOVWF	CVEEDATA	;
		MOVLW	.08			; 
		CALL	EEPROM_WRITE;

;=====@buPO @====================================

		MOVLW	.56		; l56
		MOVWF	CVEEDATA	;
		MOVLW	.09			; 
		CALL	EEPROM_WRITE;

;=====@buPP @====================================

		MOVLW	.129		; l129
		MOVWF	CVEEDATA	;
		MOVLW	.10			; 
		CALL	EEPROM_WRITE;

;=====@buPQ @====================================

		MOVLW	.248		; l248
		MOVWF	CVEEDATA	;
		MOVLW	.11			; 
		CALL	EEPROM_WRITE;

;=====@buPR @====================================

		MOVLW	.129		; l129
		MOVWF	CVEEDATA	;
		MOVLW	.12		; 
		CALL	EEPROM_WRITE;

;=====@buPS @====================================

		MOVLW	.250		; l250
		MOVWF	CVEEDATA	;
		MOVLW	.13		; 
		CALL	EEPROM_WRITE;

;=====@buPT @====================================

		MOVLW	.129		; l129
		MOVWF	CVEEDATA	;
		MOVLW	.14		; 
		CALL	EEPROM_WRITE;

;=====@buPU @====================================

		MOVLW	.252		; l252
		MOVWF	CVEEDATA	;
		MOVLW	.15		; 
		CALL	EEPROM_WRITE;

;=====@buPV @====================================

		MOVLW	.129		; l129
		MOVWF	CVEEDATA	;
		MOVLW	.16		; 
		CALL	EEPROM_WRITE;

;=====@buPW @====================================

		MOVLW	.254		; l254
		MOVWF	CVEEDATA	;
		MOVLW	.17			; 
		CALL	EEPROM_WRITE;

;=====@buPX @====================================

		MOVLW	.130		; l130
		MOVWF	CVEEDATA	;
		MOVLW	.18			; 
		CALL	EEPROM_WRITE;

;=====@buQO @====================================

		MOVLW	.248		; l248
		MOVWF	CVEEDATA	;
		MOVLW	.19			; 
		CALL	EEPROM_WRITE;

;=====@buQP @====================================

		MOVLW	.130		; l130
		MOVWF	CVEEDATA	;
		MOVLW	.20			; 
		CALL	EEPROM_WRITE;

;=====@buQQ @====================================

		MOVLW	.250		; l250
		MOVWF	CVEEDATA	;
		MOVLW	.21			; 
		CALL	EEPROM_WRITE;


CV_default_WRITE_END

		CLRF	P_REG
		BCF		SM_STATUS,0		; PageMode@flagNAi݊j
		GOTO	MAIN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Basic Acknowlegment
;	6mSec +-1mS 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BASIC_ACK



		BSF		PORTB,3

		CALL	TIME1mS
		CALL	TIME1mS
		CALL	TIME1mS
		CALL	TIME1mS
		CALL	TIME1mS
		CALL	TIME1mS

		BCF		PORTB,3

		RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Timer Routine at 4MHz (1COMMAND=1uS)
;	TIME10uS	:10uSec
;	TIME1mS		:1mSec
;	TIME60mS	:60mSec
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TIME10uS						; 1+1+1+(1+2)*2-1+2=10   10uS=10Cycle
		NOP						; 1
		MOVLW	D'2' 			; 1
		MOVWF	CNT1			; 1
T_LP1	DECFSZ	CNT1,F			; 1 OR 2		
		GOTO	T_LP1			; 2
		RETURN					; 2

TIME1mS							; 1+1+(10+2+2)*71-1+1+2=998  1mS=1000Cycle
		MOVLW	D'71' 			; 1
		MOVWF	CNT2			; 1
T_LP2	CALL	TIME10uS		; 9
		GOTO	$+1				; 2
		DECFSZ	CNT2,F			; 1 OR 2
		GOTO	T_LP2			; 2
		NOP						; 1
		RETURN					; 2



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       \Tu[`
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;=====
;~
;=====
RED

	BCF		INTCON,GIE

;	BANKSEL	PORTA
;	CLRF	PORTA
;	CLRF	PORTB

	BANKSEL	LATB
	BSF		LATB,7

	BANKSEL	PSTR1CON
	MOVLW	B'00000111'
	MOVWF	PSTR1CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_R,W
	BANKSEL	CCPR1L
	MOVWF	CCPR1L

	BANKSEL	PSTR2CON
	MOVLW	B'00000000'
	MOVWF	PSTR2CON

	BANKSEL	CCPR2L
	MOVLW	0x00
	MOVWF	CCPR2L

	BANKSEL	TMR4
	CLRF	TMR4
	BANKSEL	TMR2
	CLRF	TMR2

	RETURN

;=====
;x
;=====

YY
	BCF		INTCON,GIE

;	BANKSEL	PORTA
;	CLRF	PORTA
;	CLRF	PORTB

	BANKSEL	LATB
	BCF		LATB,7

	BANKSEL	PSTR1CON
	MOVLW	B'00001001'
	MOVWF	PSTR1CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_Y,W
	BANKSEL	CCPR1L
	MOVWF	CCPR1L

	BANKSEL	PSTR2CON
	MOVLW	B'00000000'
	MOVWF	PSTR2CON

	BANKSEL	CCPR2L
	MOVLW	0x00
	MOVWF	CCPR2L

	BANKSEL	TMR4
	CLRF	TMR4
	BANKSEL	TMR2
	CLRF	TMR2

	RETURN

;=====
;ӌ
;=====

YELLOW

	BCF		INTCON,GIE

;	BANKSEL	PORTA
;	CLRF	PORTA
;	CLRF	PORTB

	BANKSEL	LATB
	BCF		LATB,7

	BANKSEL	PSTR1CON
	MOVLW	B'000001011'
	MOVWF	PSTR1CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_Y,W
	BANKSEL	CCPR1L
	MOVWF	CCPR1L

	BANKSEL	PSTR2CON
	MOVLW	B'00000000'
	MOVWF	PSTR2CON

	BANKSEL	CCPR2L
	MOVLW	0x00
	MOVWF	CCPR2L

	BANKSEL	TMR4
	CLRF	TMR4
	BANKSEL	TMR2
	CLRF	TMR2


	RETURN

;=====
;
;=====

YG

	BCF		INTCON,GIE

;	BANKSEL	PORTA
;	CLRF	PORTA
;	CLRF	PORTB

	BANKSEL	LATB
	BCF		LATB,7

	BANKSEL	PSTR1CON
	MOVLW	B'00000110'
	MOVWF	PSTR1CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_G,W
	BANKSEL	CCPR1L
	MOVWF	CCPR1L

	BANKSEL	PSTR2CON
	MOVLW	B'00000010'
	MOVWF	PSTR2CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_Y,W
	BANKSEL	CCPR2L
	MOVWF	CCPR2L

	BANKSEL	TMR4
	CLRF	TMR4
	BANKSEL	TMR2
	CLRF	TMR2

	RETURN

;=====
;}
;=====

YGF

	BSF		INTCON,GIE

;	BANKSEL	PORTA
;	CLRF	PORTA
;	CLRF	PORTB

	BANKSEL	LATB
	BCF		LATB,7

	BANKSEL	PSTR1CON
	MOVLW	B'00000110'
	MOVWF	PSTR1CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_G,W
	BANKSEL	CCPR1L
	MOVWF	CCPR1L

	BANKSEL	PSTR2CON
	MOVLW	B'00000010'
	MOVWF	PSTR2CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_Y,W
	BANKSEL	CCPR2L
	MOVWF	CCPR2L

	BANKSEL	TMR4
	CLRF	TMR4
	BANKSEL	TMR2
	CLRF	TMR2
	
	BSF		YGF_TOGGLE,0

	RETURN

;=====
;is
;=====

GREEN

	BCF		INTCON,GIE

;	BANKSEL	PORTA
;	CLRF	PORTA
;	CLRF	PORTB

	BANKSEL	LATB
	BCF		LATB,7

	BANKSEL	PSTR1CON
	MOVLW	B'00000110'
	MOVWF	PSTR1CON

	MOVLB	B'00000'	;BANK0
	MOVF	KIDO_G,W
	BANKSEL	CCPR1L
	MOVWF	CCPR1L

	BANKSEL	PSTR2CON
	MOVLW	B'00000000'
	MOVWF	PSTR2CON

	BANKSEL	CCPR2L
	MOVLW	0x00
	MOVWF	CCPR2L

	BANKSEL	TMR4
	CLRF	TMR4
	BANKSEL	TMR2
	CLRF	TMR2


	RETURN

 

DLY1000						; 1000ms (= 50ms x 20)
		MOVLW	d'20'
		MOVWF	TMR_CNT3
DLY_100						; 50ms (= 1ms x 50)
		MOVLW	d'50'
		MOVWF	TMR_CNT1
DLP1						; 1ms (= 5us x 200)
		MOVLW	d'200'
		MOVWF	TMR_CNT2
DLP2
		NOP
		NOP
		DECFSZ	TMR_CNT2,F
		GOTO	DLP2
		DECFSZ	TMR_CNT1,F
		GOTO	DLP1
		DECFSZ	TMR_CNT3,F
		GOTO	DLY_100

		RETURN



    END